//+------------------------------------------------------------------+
//|                                            ElderThreeScreens.mq5 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//---
#define INFOPANEL_SIZE 19 //     -
#define EXPERT_NAME MQL5InfoString(MQL5_PROGRAM_NAME) //  
//---    
#include <Trade/Trade.mqh>
//---   
#include "Include\Enums.mqh"
#include "Include\InfoPanel.mqh"
#include "Include\Errors.mqh"
#include "Include\TradeSignals.mqh"
#include "Include\TradeFunctions.mqh"
#include "Include\ToString.mqh"
#include "Include\Auxiliary.mqh"
//---   
double               close_price[]; // Close (  )
double               open_price[];  // Open (  )
double               high_price[];  // High (  )
double               low_price[];   // Open (  )
//---    
double               indicator_buffer1[];
double               indicator_buffer2[];
double               indicator_buffer3[];
//---   
sinput   long              MagicNumber=777;        //  
sinput   int               Deviation=10;           // 
//---
input    ENUM_TIMEFRAMES   Screen01TimeFrame=PERIOD_W1;  //   
input    int               Screen01IndicatorPeriod=14;   //    
//---
input    ENUM_TIMEFRAMES   Screen02TimeFrame=PERIOD_D1;  //   
input    int               Screen02IndicatorPeriod=24;   //    
//---
input    ENUM_TIMEFRAMES   Screen03TimeFrame=PERIOD_H4;  //   
input    int               Screen03IndicatorPeriod=44;   //    
//---
input    double            Lot=0.1;                      // 
input    double            VolumeIncrease=0.1;           //   
input    double            VolumeIncreaseStep=10;        //    
input    double            StopLoss=50;                  //  
input    double            TakeProfit=100;               //  
input    double            TrailingStop=10;              //  
input    bool              Reverse=true;                 //  
sinput   bool              ShowInfoPanel=true;           //   
//---  
int                  Screen01IndicatorHandle=INVALID_HANDLE;   //     
int                  Screen02IndicatorHandle=INVALID_HANDLE;   //     
int                  Screen03IndicatorHandle=INVALID_HANDLE;   //     
//---     
ENUM_TIMEFRAMES  MinimumTimeframe=WRONG_VALUE;
//---  
CTrade               trade;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---       
   MinimumTimeframe=GetMinimumTimeframe(Screen01TimeFrame,Screen01IndicatorPeriod,
                                        Screen02TimeFrame,Screen02IndicatorPeriod,
                                        Screen03TimeFrame,Screen03IndicatorPeriod);
//---   
   GetIndicatorHandles();
//---   
   CheckNewBar();
//---  
   GetPositionProperties(P_ALL);
//---   
   SetInfoPanel();
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---     
   Print(GetDeinitReasonText(reason));
//---    
   if(reason==REASON_REMOVE)
     {
      //---     ,     
      DeleteInfoPanel();
      //---   
      IndicatorRelease(Screen01IndicatorHandle);
      IndicatorRelease(Screen02IndicatorHandle);
      IndicatorRelease(Screen03IndicatorHandle);
     }
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---    , 
   if(!CheckNewBar())
     {
      if(IsVisualMode() || IsRealtime())
        {
         //---       
         GetPositionProperties(P_ALL);
         //--- /  
         SetInfoPanel();
        }
      return;
     }

//---    
   else
     {
      //---    
      if(CheckTradingPermission()==0)
        {
         if(!GetIndicatorsData())
            return;
         GetBarsData();          //   
         TradingBlock();         //    
         ModifyTrailingStop();   //   Trailing Stop
        }
     }
//---  
   GetPositionProperties(P_ALL);
//---   
   SetInfoPanel();
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---   
   GetPositionProperties(P_ALL);
//---   
   SetInfoPanel();
  }
//+------------------------------------------------------------------+
